/**
 * monologue.js - EventEmitter replacement with AMQP-style bindings and other advanced features. Compatible with postal.js's API.
 * Author: Jim Cowart (http://ifandelse.com)
 * Version: v0.3.2
 * Url: https://github.com/postaljs/monologue.js
 * License(s): MIT, GPL
 */
(function(t,n){"function"==typeof define&&define.amd?define(["lodash","riveter"],function(e,i){return n(e,i,t)}):"object"==typeof module&&module.exports?module.exports=n(require("lodash"),require("riveter")):t.Monologue=n(t._,t.riveter,t)})(this,function(t,n,e,i){function c(t,n){return function(){if(console.warn||console.log){var e="Warning, the "+t+" method has been deprecated. Please use "+n+" instead.";console.warn?console.warn(e):console.log(e)}return h.prototype[n].apply(this,arguments)}}function r(t,n,e){return function(i){_.resolver.compare(i.topic,t)&&(n.push(i),i.cacheKeys.push(t),e&&e(i))}}function o(t,n,e){return function(i,c,r){i===t&&r.splice(c,1),0===r.length&&delete e[n]}}function s(n,e,i,c){if(n.inactive=!0,c.splice(i,1),n.cacheKeys&&n.cacheKeys.length)for(var r;r=n.cacheKeys.pop();)t.each(e._cache[r],o(n,r,e._cache))}var u="|",a={cache:{},regex:{},compare:function(n,e){var i,c,r,o=this.cache[e+u+n];return o===!0?o:-1===n.indexOf("#")&&-1===n.indexOf("*")?o=this.cache[e+u+n]=e===n:((c=this.regex[n])||(i="^"+t.map(n.split("."),function(t){var n="";return r&&(n="#"!==r?"\\.\\b":"\\b"),n+="#"===t?"[\\s\\S]*":"*"===t?"[^.]+":t,r=t,n}).join("")+"$",c=this.regex[n]=new RegExp(i)),o=this.cache[e+u+n]=c.test(e))},reset:function(){this.cache={},this.regex={}},purge:function(n){var e=this,i=function(t,i){var c=i.split(u),r=c[0],o=c[1];"undefined"!=typeof n.topic&&n.topic!==r||"undefined"!=typeof n.binding&&n.binding!==o||delete e.cache[i]};"undefined"==typeof n?this.reset():t.each(this.cache,i)}},h=function(t,n,e){this.topic=t,this.callback=n,this.pipeline=[],this.cacheKeys=[],this._context=i,this.emitter=e},f=function(){var n;return function(e){var i=!1;return t.isString(e)?(i=e===n,n=e):(i=t.isEqual(e,n),n=t.clone(e)),!i}},p=function(){var n=[];return function(e){var i=!t.any(n,function(n){return t.isObject(e)||t.isArray(e)?t.isEqual(e,n):e===n});return i&&n.push(e),i}};h.prototype={"catch":function(t){var n=this.callback,e=function(){try{n.apply(this,arguments)}catch(e){t(e,arguments[0])}};return this.callback=e,this},defer:function(){return this.delay(0)},disposeAfter:function(n){if(!t.isNumber(n)||0>=n)throw new Error("The value provided to disposeAfter (maxCalls) must be a number greater than zero.");var e=this,i=t.after(n,t.bind(function(){e.unsubscribe()}));return e.pipeline.push(function(t,n,e){e(t,n),i()}),e},distinct:function(){return this.constraint(new p)},distinctUntilChanged:function(){return this.constraint(new f)},invokeSubscriber:function(t,n){if(!this.inactive){var e=this,i=e.pipeline,c=i.length,r=e._context,o=-1;if(c){i=i.concat([e.callback]);var s=function u(t,n){o+=1,c>o?i[o].call(r,t,n,u):e.callback.call(r,t,n)};s(t,n,0)}else e.callback.call(r,t,n)}},logError:function(){if(console){var t;t=console.warn?console.warn:console.log,this["catch"](t)}return this},once:function(){return this.disposeAfter(1)},unsubscribe:function(){this.inactive||this.emitter.off(this)},constraint:function(n){if(!t.isFunction(n))throw new Error("Predicate constraint must be a function");return this.pipeline.push(function(t,e,i){n.call(this,t,e)&&i(t,e)}),this},constraints:function(n){var e=this;return t.isArray(n)&&t.each(n,function(t){e.constraint(t)}),e},context:function(t){return this._context=t,this},debounce:function(n,e){if(!t.isNumber(n))throw new Error("Milliseconds must be a number");return this.pipeline.push(t.debounce(function(t,n,e){e(t,n)},n,!!e)),this},delay:function(n){if(!t.isNumber(n))throw new Error("Milliseconds must be a number");var e=this;return e.pipeline.push(function(t,e,i){setTimeout(function(){i(t,e)},n)}),this},throttle:function(n){if(!t.isNumber(n))throw new Error("Milliseconds must be a number");var e=function(t,n,e){e(t,n)};return this.pipeline.push(t.throttle(e,n)),this}},h.prototype.off=h.prototype.unsubscribe;for(var l=["withConstraint","withConstraints","withContext","withDebounce","withDelay","withThrottle"],b=["constraint","constraints","context","debounce","delay","throttle"],d=0;6>d;d++){var v=l[d];h.prototype[v]=c(v,b[d])}var _=function(){};return _.prototype={on:function(n,e){var i=this;i._subscriptions=i._subscriptions||{},i._subscriptions[n]=i._subscriptions[n]||[];var c=new h(n,e,i);return i._subscriptions[n].push(c),t.each(i._cache,function(t,n){r(n,t)(c)}),i._subscriptions[n][i._subscriptions[n].length-1]},once:function(t,n){return this.on(t,n).once()},off:function(n,e){var i=this;switch(i._subscriptions=i._subscriptions||{},i._cache=i._cache||{},arguments.length){case 0:t.each(i._subscriptions,function(n){t.each(n,function(t,e){s(t,i,e,n)})}),i._subscriptions={};break;case 1:var c="[object String]"===Object.prototype.toString.call(n)?"topic":n instanceof h?"def":"context";switch(c){case"topic":i._subscriptions[n]&&t.each(i._subscriptions[n],function(t,e){s(t,i,e,i._subscriptions[n])});break;case"context":t.each(i._subscriptions,function(e){t.each(t.clone(e),function(t,c){t._context===n&&s(t,i,c,e)})});break;default:t.each(i._subscriptions[n.topic],function(t,e){t===n&&s(t,i,e,i._subscriptions[n.topic])})}break;default:t.each(t.clone(i._subscriptions[n]),function(t,c){t._context===e&&s(t,i,c,i._subscriptions[n])})}},emit:function(n,e){var i=this.getEnvelope(n,e);this._cache=this._cache||{};var c=this._cache[n],o=function(t){t.invokeSubscriber(i.data,i)};if(c)t.each(c,o);else{c=this._cache[n]=[];var s=r(n,c,o);t.each(this._subscriptions,function(n){t.each(Array.prototype.slice.call(n,0),s)})}},getEnvelope:function(t,n){return{topic:t,timeStamp:new Date,data:n}}},_.resolver=a,_.debug=!1,_.SubscriptionDefinition=h,n(_),_.mixInto=function(t){n.punch(t,_.prototype)},_});